Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.catalina.websocket
Class WebSocketServlet

    java.lang.Object
      javax.servlet.GenericServlet
          javax.servlet.http.HttpServlet
              org.apache.catalina.websocket.WebSocketServlet

All Implemented Interfaces:
  Serializable, Servlet, ServletConfig

    public abstract class WebSocketServlet

extends HttpServlet

Provides the base implementation of a Servlet for processing WebSocket connections as per RFC6455. It is expected that applications will extend this implementation and provide application specific functionality.

See Also:
  Serialized Form

Constructor Summary
`WebSocketServlet()`

Method Summary
`protected abstract StreamInbound` | `createWebSocketInbound(String subProtocol, HttpServletRequest request)` Create the instance that will process this inbound connection.
`protected void` | `doGet(HttpServletRequest req, HttpServletResponse resp)` Called by the server (via the `service` method) to allow a servlet to handle a GET request.
`protected String` | `selectSubProtocol(List<String> subProtocols)` Intended to be overridden by sub-classes that wish to select a sub-protocol if the client provides a list of supported protocols.
`protected boolean` | `verifyOrigin(String origin)` Intended to be overridden by sub-classes that wish to verify the origin of a WebSocket request before processing it.

Methods inherited from class javax.servlet.http.HttpServlet
`doDelete, doHead, doOptions, doPost, doPut, doTrace, getLastModified, service, service`

Methods inherited from class javax.servlet.GenericServlet
`destroy, getInitParameter, getInitParameterNames, getServletConfig, getServletContext, getServletInfo, getServletName, init, init, log, log`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### WebSocketServlet

    public WebSocketServlet()

Method Detail

### doGet

    protected void doGet(HttpServletRequest req,
                         HttpServletResponse resp)
                  throws ServletException,
                         IOException

  Description copied from class: `javax.servlet.http.HttpServlet`
  Called by the server (via the `service` method) to allow a servlet to handle a GET request.

  Overriding this method to support a GET request also automatically supports an HTTP HEAD request. A HEAD request is a GET request that returns no body in the response, only the request header fields.

  When overriding this method, read the request data, write the response headers, get the response's writer or output stream object, and finally, write the response data. It's best to include content type and encoding. When using a `PrintWriter` object to return the response, set the content type before accessing the `PrintWriter` object.

  The servlet container must write the headers before committing the response, because in HTTP the headers must be sent before the response body.

  Where possible, set the Content-Length header (with the `ServletResponse.setContentLength(int)` method), to allow the servlet container to use a persistent connection to return its response to the client, improving performance. The content length is automatically set if the entire response fits inside the response buffer.

  When using HTTP 1.1 chunked encoding (which means that the response has a Transfer-Encoding header), do not set the Content-Length header.

  The GET method should be safe, that is, without any side effects for which users are held responsible. For example, most form queries have no side effects. If a client request is intended to change stored data, the request should use some other HTTP method.

  The GET method should also be idempotent, meaning that it can be safely repeated. Sometimes making a method safe also makes it idempotent. For example, repeating queries is both safe and idempotent, but buying a product online or modifying data is neither safe nor idempotent.

  If the request is incorrectly formatted, `doGet` returns an HTTP "Bad Request" message.

  Overrides:
    `doGet` in class `HttpServlet`
  Parameters:
    `req` - an `HttpServletRequest` object that contains the request the client has made of the servlet
    `resp` - an `HttpServletResponse` object that contains the response the servlet sends to the client
  Throws:
    `ServletException` - if the request for the GET could not be handled
    `IOException` - if an input or output error is detected when the servlet handles the GET request
  See Also:
    `ServletResponse.setContentType(java.lang.String)`

### verifyOrigin

    protected boolean verifyOrigin(String origin)

  Intended to be overridden by sub-classes that wish to verify the origin of a WebSocket request before processing it.

  Parameters:
    `origin` - The value of the origin header from the request which may be `null`
  Returns:
    `true` to accept the request. `false` to reject it. This default implementation always returns `true`.

### selectSubProtocol

    protected String selectSubProtocol(List<String> subProtocols)

  Intended to be overridden by sub-classes that wish to select a sub-protocol if the client provides a list of supported protocols.

  Parameters:
    `subProtocols` - The list of sub-protocols supported by the client in client preference order. The server is under no obligation to respect the declared preference
  Returns:
    `null` if no sub-protocol is selected or the name of the protocol which must be one of the protocols listed by the client. This default implementation always returns `null`.

### createWebSocketInbound

    protected abstract StreamInbound createWebSocketInbound(String subProtocol,
                                                            HttpServletRequest request)

  Create the instance that will process this inbound connection. Applications must provide a new instance for each connection.

  Parameters:
    `subProtocol` - The sub-protocol agreed between the client and server or `null` if none was agreed
    `request` - The HTTP request that initiated this WebSocket connection. Note that this object is only valid inside this method. You must not retain a reference to it outside the execution of this method. If Tomcat detects such access, it will throw an IllegalStateException

Overview | Package | Class | Tree | Deprecated | Index | Help
| Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2012 Apache Software Foundation. All Rights Reserved.